#!/bin/sh

SD_PATH=/run/media/mmcblk1p1/
DEFAULT_PATH=/dev/Downloads/

echo "Killing all Insight processes..."
pkill Insight
echo "done"

sleep 2

pkill -9 Insight

# Restart dropbear to prevent dropbear from holding up the UART
echo "Force kill of dropbear..."
pkill -9 dropbear

## Delete stored data [Causes Backlogged data loss]
## 	MAG enabled these for develpment 11/5/2019
echo "Deleting database..."
rm -f /Insight/log/repo.db
rm -f /Insight/core_accumulator.nv
rm -f /run/media/mmcblk1p1/repo.db
rm -f /run/media/mmcblk1p1/core_accumulator.nv

echo "Backing up old binaries..."
mkdir -p /dev/Backups
cp -r /Insight/{Applications,lib,Scripts,keys,repo.config,config.json} /dev/Backups/
echo "done"

echo "Replacing old binaries..."
if [ -d "$SD_PATH" ]; then
	cp -a ${SD_PATH}Insight/{Applications,lib,Scripts,keys,repo.config,config.json} /Insight/ 2>/dev/null
	rm -rf ${SD_PATH}Insight/{Applications,lib,Scripts,keys,repo.config,config.json}
	rm -f ${SD_PATH}*.swu
	cp -a ${SD_PATH}Downloads/Insight/{Applications,lib,Scripts,keys,repo.config,config.json} /Insight/
	echo "Copied binaries from $SD_PATH"
else
	cp -a ${DEFAULT_PATH}Insight/{Applications,lib,Scripts,keys,repo.config,config.json} /Insight/ 2>/dev/null
	echo "Copied binaries from $DEFAULT_PATH"
fi

# Delete logs to accommodate new log file size. Remove this for releases after Rev C
rm /Insight/log/*
echo "Deleted all existing logs !"

echo "Restarting processes"
chmod +x /Insight/Applications/* /Insight/Scripts/*
/Insight/Applications/SystemMonitor -x
echo "done"

echo "Waiting for SystemMonitor to start and terminate this script"
sleep 5
echo "done"

############################################################
# Firmware update has failed. Revert back to old firmware
############################################################

echo "!!! Upgrade failed. Killing processes..."
# Kill all Insight processes 
pkill -9 Insight
echo "done"

echo "Reverting to old files..."
# revert to old files
cp -a /dev/Backups/* /Insight/
echo "done"

echo "Restarting processes"
# Restart processes
/Insight/Applications/SystemMonitor -x
echo "done"
