#!/bin/sh

# Usage: keycheck.sh <serial number>
#if [ "$#" -ne 1 ]; then
#    echo ""
#    echo "Illegal number of parameters."
#    echo "Usage: keycheck.sh <serial number>"
#    echo ""
#    exit 0
#fi

# Extract serial number from identity config file
#SERIAL_NUMBER=`sed -n -e "s/.*serialNumber.*:\"\(.*\)\"/\1/p"  identity.config | sed -n -e "s/\".*/\1/p"`

SERIAL_NUMBER=$1

# Build key check URL inserting base64 MD5 hash of the key
# This will be evaluated on the server and return 200 if key hash matches the 
# key with the same serial number on the server.
URL="https://collector.millerwelds.com/Auth/ValidateDeviceRegistration?Base64EncodedSharedKeyHash=`openssl dgst -md5 -binary /Insight/keys/id.key | base64`&DeviceSerial=$SERIAL_NUMBER" 

# Submit the URL to the server using wget
wget -O keycheckout.txt -S $URL



