<?php 

$Info_filespec = "/Insight/system.info";

$NetworkSettings = ReadSettings($Info_filespec);
$ConfigSettings = ReadSettings($Config_filespec);
//echo "Stored NetworkSettings:<br>";
//print_r($NetworkSettings);

$NetworkSettings = MergePostSettings($Info_filespec, $NetworkSettings);

function MergePostSettings($filespec, $settings)
{
	// Check if new settings have been submitted
	if(!empty($_POST))
	{
		// echo "<br>Post:<br>";
		// print_r($_POST);
		$File = fopen($filespec, "w");
		if($File == NULL)
		{
			echo "Error opening " . $filespec . "<br>";
		}
		else
		{
			// Combine stored settings with new post
			if(!empty($settings))
			{
				$settings = array_merge($settings, $_POST);
			}
			else
			{
				$settings = $_POST;
			}
			
			$settings["SettingsApplied"] = "false";
			
			// Convert network settings to JSON
			$settings_json = json_encode($settings);
			
			fwrite($File, $settings_json);
			fwrite($File, "\n\n");
			fflush($File);
			fclose($File);
		}
		// Clear the file stats cache since we will re-read the file.  Not clearing
		// the stat cache will cause filesize() to report the value from the previous
		// call to ReadNetworkSettings()
		clearstatcache();
		$settings = ReadSettings($filespec);
		// echo "<br>Merged Settings:<br>";
		// print_r($settings);
	}
	return $settings;
}

function ReadSettings($filespec)
{
	// Read network settings
	$errorLvl = get_cfg_var('display_errors');
	error_reporting(E_ERROR);
	$File = fopen($filespec, "r");
	error_reporting($errorLvl);

	if($File == NULL)
	{
		return NULL;
	}
	else
	{
		$NetworkSettings_json = fread($File, filesize($filespec));
		fclose($File);
		$Settings = json_decode($NetworkSettings_json, true);
		$count = 0;
		//echo "<br>File read NetworkSettings:<br>";
		//print_r($Settings);
	}
	return $Settings;
}

function UpdateSBCSettings()
{
	$Config_filespec = "/Insight/devicePage2SBC.conf";
	// Check if new settings have been submitted
	if(!empty($_POST))
	{
		$stored = ReadSettings($Config_filespec);

		// echo "<br>Post:<br>";
		// print_r($_POST);
		$File = fopen($Config_filespec, "w");
		if($File == NULL)
		{
			echo "Error opening " . $Config_filespec . "<br>";
		}
		else
		{
			$settings = $_POST;
			
			// ------------- WiFi Settings
			
			// Remove DHCP fields if DHCP is dynamic
			if(array_key_exists('WiFiDHCP', $settings) && $settings['WiFiDHCP'] == 'dynamic')
			{
				unset($settings['WiFiIP']);
				unset($settings['WiFiSubnet']);
				unset($settings['WiFiGateway']);
			}
			// Remove DNS fields if DNS is dynamic
			if(array_key_exists('WiFiDNS', $settings) && $settings['WiFiDNS'] == 'dynamic')
			{
				unset($settings['WiFiDNSAddr']);
			}
			
			// Remove Encryption field if not WPA or WPA2
			if(array_key_exists('Authentication', $settings) && 
				!($settings['Authentication'] == "WPA" || $settings['Authentication'] == "WPA2"))
			{
				unset($settings['Encryption']);
			}
			
			// If Authentication is WEP check the field length to see if it is hex or ascii
			if(array_key_exists('Authentication', $settings) && 
				($settings['Authentication'] == "WEP_Open" || $settings['Authentication'] == "WEP_Shared"))
			{
				if(strlen($settings['Passkey']) == 10 || strlen($settings['Passkey']) == 26)
				{
					$settings['KeyIsHex'] = 1;
				}
				else 
				{
					$settings['KeyIsHex'] = 0;
				}
			}
			
			// ------------- Ethernet Settings
			// Remove DHCP fields if DHCP is dynamic
			if(array_key_exists('EthDHCP', $settings) && $settings['EthDHCP'] == 'dynamic')
			{
				unset($settings['EthIP']);
				unset($settings['EthSubnet']);
				unset($settings['EthGateway']);
			}
			// Remove DNS fields if DNS is dynamic
			if(array_key_exists('EthDNS', $settings) && $settings['EthDNS'] == 'dynamic')
			{
				unset($settings['EthDNSAddr']);
			}
			
			// ------------- Store Settings
			
			// Combine stored settings with new post
			if(!empty($stored))
			{
				$settings = array_merge($stored, $settings);
			}
			
			// Convert network settings to JSON
			$settings_json = json_encode($settings);
			
			fwrite($File, $settings_json);
			fwrite($File, "\n\n");
			fflush($File);
			fclose($File);
		}
	}
}

?>
