﻿<?php 

// Get Ethernet MAC  - perform a grep on ifconfig shell command and extract the Ethernet MAC
$ifconfig_grep_string = "ifconfig | grep wlan0";
$ifgrep_out = exec($ifconfig_grep_string);
$search_string = "HWaddr ";
$WiFi_MAC = substr($ifgrep_out, strpos($ifgrep_out, $search_string) + strlen($search_string));

// Get network settings
require('network_settings.php');
//echo "NetworkSettings:<br>";
//print_r($NetworkSettings);

$SSID = $NetworkSettings['SSID'];
$Passkey = $NetworkSettings['Passkey'];
$Authentication = $NetworkSettings['Authentication'];
$Encryption = $NetworkSettings['Encryption'];
$WEP_Type = $NetworkSettings['WEP_Type'];

$WiFiDHCP = $NetworkSettings['WiFiDHCP'];
$WiFiIP = $NetworkSettings['WiFiIP'];
$WiFiSubnet = $NetworkSettings['WiFiSubnet'];
$WiFiGateway = $NetworkSettings['WiFiGateway'];
$WiFiDNS = $NetworkSettings['WiFiDNS'];
$WiFiDNSAddr = $NetworkSettings['WiFiDNSAddr'];

UpdateSBCSettings();


?>
<!DOCTYPE html>
<html lang="en">
  <?php require('head.php'); ?>
<script type="text/javascript" >
 <?php require('wifi.js'); ?>
function InitialSettings()
{
	var dhcp = "<?php echo $WiFiDHCP; ?>"
	var dns = "<?php echo $WiFiDNS; ?>"
		
	DHCP_Toggle(dhcp);
	DNS_Toggle(dns);
	//document.getElementById("Passkey").value = "<?php echo $Passkey ?>";
	UpdateFields();
}
function DHCP_Toggle(selection)
{
	var static_button = document.getElementById("static_b");
	var dynamic_button = document.getElementById("dynamic_b");
	var DHCP_enabled = dynamic_button.classList.contains("btn-warning");
	
	if(selection == "static")
	{
		dynamic_button.classList.remove("btn-warning");
		dynamic_button.classList.add("btn-default");
		static_button.classList.remove("btn-default");
		static_button.classList.add("btn-warning");
		document.getElementById("WiFiDHCP").value = "static";
		DHCP_FieldsEnable(true);
	}
	else
	{
		static_button.classList.remove("btn-warning");
		static_button.classList.add("btn-default");
		dynamic_button.classList.remove("btn-default");
		dynamic_button.classList.add("btn-warning");
		document.getElementById("WiFiDHCP").value = "dynamic";
		DHCP_FieldsEnable(false);
	}
}
function DHCP_FieldsEnable(enable)
{
	var index
	var id_string = "spinEdit";
	for(index = 17; index <= 28; index++)
	{
		var id = id_string.concat(index);
		document.getElementById(id).disabled = !enable;
	}
}
function DNS_Toggle(selection)
{
	var static_button = document.getElementById("specific_server_b");
	var dynamic_button = document.getElementById("dhcp_auto_b");
	var DHCP_enabled = dynamic_button.classList.contains("btn-warning");
	
	if(selection == "static")
	{
		dynamic_button.classList.remove("btn-warning");
		dynamic_button.classList.add("btn-default");
		static_button.classList.remove("btn-default");
		static_button.classList.add("btn-warning");
		document.getElementById("WiFiDNS").value = "static";
		DNS_FieldsEnable(true);
	}
	else
	{
		static_button.classList.remove("btn-warning");
		static_button.classList.add("btn-default");
		dynamic_button.classList.remove("btn-default");
		dynamic_button.classList.add("btn-warning");
		document.getElementById("WiFiDNS").value = "dynamic";
		DNS_FieldsEnable(false);
	}
}
function DNS_FieldsEnable(enable)
{
	var index
	var id_string = "spinEdit";
	for(index = 37; index <= 40; index++)
	{
		var id = id_string.concat(index);
		document.getElementById(id).disabled = !enable;
	}
}
function UpdateFields()
{
	// Show Encryption block only if authentication is WPA or WPA2
	if(document.getElementById("Authentication").value == "WPA" || 
		document.getElementById("Authentication").value == "WPA2")
	{
		document.getElementById("EncryptionBlock").style.visibility = "visible";
	}
	else 
	{
		document.getElementById("EncryptionBlock").style.visibility = "collapse";
	}
}
</script> 
  <body onload="$('.selectpicker').selectpicker();  InitialSettings();">
    <!-- Modal -->
        <div class="modal fade bs-example-modal-sm" id="ipAddressChangeModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header bg-info">
                <button id="initial_close" type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="myModalLabel"><span class="glyphicon glyphicon-info-sign"></span> Information</h4>
              </div>
              <div class="modal-body">
                <h4 id="first_important" class="bg-warning"><span class="glyphicon glyphicon-warning-sign"></span> Important!</h4>
                <p id="port_change">If you have changed the IP Address of the WiFi port you are currently connected to, you will need to enter the new address in the browser address bar to continue viewing web pages.</p>  
              </div>
              <div class="modal-footer">
                <ul class="pager">
                    <li><a id="first_continue" href="#" onclick="wifiSubmit()" data-dismiss="modal">Continue <span class="glyphicon glyphicon-save"></span><span class="sr-only">(current)</span></a></li>
                    <li class="cancel"><a id="first_cancel" href="#" data-dismiss="modal">Cancel <span class="glyphicon glyphicon-ban-circle"></span><span class="sr-only">(current)</span></a></li>
                </ul>
              </div>
            </div>
          </div>
        </div>
        <div class="modal fade bs-example-modal-sm" id="invalidAddressModal" tabindex="-1" role="dialog" aria-labelledby="invalidAddressLabel" aria-hidden="true">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header bg-info">
                <button id="first_close" type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 id="information_header" class="modal-title"><span class="glyphicon glyphicon-info-sign"></span> Information</h4>
              </div>
              <div class="modal-body">
                <h4 id="second_important" class="bg-warning"><span class="glyphicon glyphicon-warning-sign"></span> Important!</h4>
                <p id="invalid">One or more of the entered fields is invalid.  Please re-enter all required fields with valid information.</p>  
              </div>
              <div class="modal-footer">
                <ul class="pager">
                    <li class="cancel"><a id="second_close" href="#" data-dismiss="modal">Close <span class="glyphicon glyphicon-ban-circle"></span><span class="sr-only">(current)</span></a></li>
                </ul>
              </div>
            </div>
          </div>
        </div>
      <div class="container">
        <div class="panel panel-primary">
          <div class="panel-body">
              <?php require('navbar_header.php'); ?>
              <div class="panel">
                <div class="panel-heading">
                    <h3 id="third_important" class="panel-title"><span class="glyphicon glyphicon-warning-sign"></span> IMPORTANT!</h3>
                </div>
                <div class="panel-body bg-warning">
                    <p id="modification" class="bg-warning">Modifying these values without an understanding of WiFi settings may result in the unit being unreachable.</p>
                    <p id="local_it" class="bg-warning">Please contact your local IT expert if you are unsure of how to proceed.</p>
					</div>
             </div>
             <div class="panel panel-primary">
                    <div class="panel-heading">
                        <h3 id="wifi_header" class="panel-title"><span class="glyphicon glyphicon-cog"></span> WiFi Setup</h3>
                    </div>
                    <div class="panel-body">
                        <div class="row">
                            <div class="col-md-8 col-md-offset-2">
                                <div class="panel panel-info">
                                    <div class="panel-heading">
                                        <h3 id="wifi_info_header" class="panel-title"><span class="glyphicon glyphicon-info-sign"></span> WiFi Information</h3>
                                    </div>
                                    <div class="panel-body">
                                        <h5 id="mac_b">MAC:  <?PHP echo $WiFi_MAC; ?></h5>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                          <form action="/setup/wifi.min.php" enctype="multipart/form-data" method="post" id="cont_wifi_security" name="cont_wifi_security">
                            <div class="col-md-8 col-md-offset-2">
                                <div class="panel panel-primary">
                                    <div class="panel-heading">
                                        <h3 id="security_header" class="panel-title"><span class="glyphicon glyphicon-cog"></span> Security Setup</h3>
                                    </div>
                                    <div class="panel-body">
                                        <div class="row">
                                            <label for="asset" class="col-md-4 control-label">SSID</label>
                                            <div class="col-md-8">
												<input id="SSID"  style="text-align:left" maxlength="32" class="form-control" name="SSID" value="<?php echo $SSID; ?>"/>
	                                        </div>
                                        </div>
                                        <div class="row">
                                            &nbsp;
                                        </div>
                                        <div class="row">
                                            <label id="authentication" for="authenticationTypes" class="col-md-4 control-label">Authentication</label>
                                            <div class="col-md-8">
                                                <select class="selectpicker" id="Authentication" name="Authentication" data-style="btn-primary" onchange="UpdateFields()">
                                                    <option id="none" value="None" <?php if($Authentication == "None") echo "selected=\"selected\""; ?>>None</option>
                                                    <option id="wep_open" value="WEP_Open" <?php if($Authentication == "WEP_Open") echo "selected=\"selected\""; ?>>WEP Open</option>
                                                    <option id="wep_shared" value="WEP_Shared" <?php if($Authentication == "WEP_Shared") echo "selected=\"selected\""; ?>>WEP Shared</option>
                                                    <option id="wpa" value="WPA" <?php if($Authentication == "WPA") echo "selected=\"selected\""; ?>>WPA</option>
                                                    <option id="wpa2" value="WPA2" <?php if($Authentication == "WPA2") echo "selected=\"selected\""; ?>>WPA2</option>
                                                </select>
                                            </div>
                                        </div>
                                         <div class="row">
                                            &nbsp;
                                        </div>
                                        <div class="row" id="EncryptionBlock">
                                            <label id="encryption" for="encryptionTypes" class="col-md-4 control-label">Encryption</label>
                                            <div class="col-md-8">
                                                <select class="selectpicker" id="Encryption" name="Encryption" data-style="btn-primary">
                                                    <option value="AES" <?php if($Encryption == "AES") echo "selected=\"selected\""; ?>>AES</option>
                                                    <option value="TKIP" <?php if($Encryption == "TKIP") echo "selected=\"selected\""; ?>>TKIP</option>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="row">
                                            &nbsp;
                                        </div>
                                        <div class="row">
                                            <label id="password" for="wifi_password" class="col-md-4 control-label">Password</label>
                                            <div class="col-md-8">
                                                <input id="wifi_password" style="text-align:left" type="password" maxlength="64" class="form-control" name="Passkey" value="<?php echo $Passkey; ?>"/>
			                                    <!--input class="hidden_values" type="hidden" name="WiFiDHCP" id="WiFiDHCP" value="" /-->
                                                <input class="hidden_values" type="hidden" name="WiFiCredentialsChanged" id="WiFiCredentialsChanged" value="true" />
                                            </div>
                                        </div>
                                        <div class="row">
                                            &nbsp;
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6 col-md-offset-4">
                                                <ul class="pager">
                                                    <li class="edit">
                                                        <a id="security_change" href="#" onclick="document.getElementById('cont_wifi_security').submit();">
                                                            Save Security Settings 
                                                            <span class="glyphicon glyphicon-save"></span>
                                                            <span class="sr-only">(current)</span>
                                                        </a>
                                                    </li>
                                                </ul>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
						  </form>
						</div>
                        <div class="row">
                            <div class="col-md-8 col-md-offset-2">
                              <form action="/setup/wifi.min.php" enctype="multipart/form-data" method="post" id="cont_wifi_ip" name="cont_wifi_ip">
                                <div class="panel panel-info">
                                     <div class="panel-heading">
                                        <h3 id="wifi_address" class="panel-title"><span class="glyphicon glyphicon-info-sign"></span> WiFi Address</h3>
                                    </div>
                                    <div class="panel-body">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="btn-group">
                                                    <div class="btn-group btn-toggle" data-toggle="buttons">
                                                        <label label-default="" class="btn btn-default" id="static_b"  onclick = "DHCP_Toggle('static');">
                                                            Static
                                                        </label>
                                                        <label label-default="" class="btn btn-warning" id="dynamic_b" onclick = "DHCP_Toggle('dynamic');">
                                                            Dynamic
                                                        </label>
                                                        <input class="hidden_values" type="hidden" name="WiFiDHCP" id="WiFiDHCP" value="" />
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-12">
                                                &nbsp;
                                            </div>
                                        </div>
                                        <div id="wifi_addresses" class="panel panel-primary">
                                            <div class="panel-heading">
                                                <h3 id="network_header" class="panel-title"><span class="glyphicon glyphicon-info-sign"></span> Network Information</h3>
                                            </div>
                                            <div class="panel-body">
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        <label id="ip_address" for="ipaddress" class="col-md-4 control-label numonly">IP Address</label>
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit17" id="Label16"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit17" class="aSpinEdit form-control" name="WiFiIP[0]" value="<?php echo $WiFiIP[0] ?>"/>
																 <input class="hidden_values" type="hidden" name="IPSettingsChanged" id="IPSettingsChanged" value="true" />
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit18" id="Label17"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit18" class="aSpinEdit form-control" name="WiFiIP[1]" value="<?php echo $WiFiIP[1] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit19" id="Label18"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit19" class="aSpinEdit form-control" name="WiFiIP[2]" value="<?php echo $WiFiIP[2] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit20" id="Label19"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit20" class="aSpinEdit form-control" name="WiFiIP[3]" value="<?php echo $WiFiIP[3] ?>"/>
                                                            </span>
                                                        </div>
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        &nbsp;
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        <label id="subnet" for="subnetmask" class="col-md-4 control-label numonly">Subnet Mask</label>
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit21" id="Label20"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit21" class="aSpinEdit form-control" name="WiFiSubnet[0]" value="<?php echo $WiFiSubnet[0] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit22" id="Label21"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit22" class="aSpinEdit form-control" name="WiFiSubnet[1]" value="<?php echo $WiFiSubnet[1] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit23" id="Label22"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit23" class="aSpinEdit form-control" name="WiFiSubnet[2]" value="<?php echo $WiFiSubnet[2] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit24" id="Label23"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit24" class="aSpinEdit form-control" name="WiFiSubnet[3]" value="<?php echo $WiFiSubnet[3] ?>"/>
                                                            </span>
                                                        </div>
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        &nbsp;
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        <label id="gateway" for="networkgateway" class="col-md-12 control-label numonly">Network Gateway</label>
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit25" id="Label24"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit25" class="aSpinEdit form-control" name="WiFiGateway[0]" value="<?php echo $WiFiGateway[0] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit26" id="Label25"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit26" class="aSpinEdit form-control" name="WiFiGateway[1]" value="<?php echo $WiFiGateway[1] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit27" id="Label26"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit27" class="aSpinEdit form-control" name="WiFiGateway[2]" value="<?php echo $WiFiGateway[2] ?>"/>
                                                            </span>
                                                        </div>
                                                        <div class="col-md-3">
                                                            <label class="control-label" for="spinEdit28" id="Label27"></label>
                                                            <span class="input-group-addon">
                                                                 <input type="text" id="spinEdit28" class="aSpinEdit form-control" name="WiFiGateway[3]" value="<?php echo $WiFiGateway[3] ?>"/>
                                                            </span>
                                                        </div>
                                                    </div>
                                                  </div>
                                                  <div class="row">
                                                    <div class="col-md-12">
                                                        &nbsp;
                                                    </div>
                                                  </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-12">
                                                &nbsp;
                                            </div>
                                        </div>
                                        <div class="panel panel-primary">
                                            <div class="panel-heading">
                                                <h3 id="dns" class="panel-title">DNS Address</h3>
                                            </div>
                                            <div class="panel-body">
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        <div class="btn-group">
                                                            <div class="btn-group btn-toggle" data-toggle="buttons">
                                                                <label label-default="" class="btn btn-default" id="dhcp_auto_b" onclick="DNS_Toggle('dynamic')">
                                                                    DHCP Automatic
                                                                </label>
                                                                <label label-default="" class="btn btn-warning" id="specific_server_b" onclick="DNS_Toggle('static')">
                                                                    DNS Server
                                                                </label>
                                                                <input class="hidden_values" type="hidden" name="WiFiDNS" id="WiFiDNS" value="" />
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="row">
                                                    <div class="col-md-12">
                                                        &nbsp;
                                                    </div>
                                                </div>
                                                <div id="dns1">
                                                    <div class="row">
                                                        <div class="col-md-12">
                                                            <div class="col-md-3">
                                                                <label class="control-label" for="spinEdit37" id="Label36"></label>
                                                                <span class="input-group-addon">
                                                                     <input type="text" id="spinEdit37" class="aSpinEdit form-control" name="WiFiDNSAddr[0]" value="<?php echo $WiFiDNSAddr[0] ?>"/>
                                                                </span>
                                                            </div>
                                                            <div class="col-md-3">
                                                                <label class="control-label" for="spinEdit38" id="Label37"></label>
                                                                <span class="input-group-addon">
                                                                     <input type="text" id="spinEdit38" class="aSpinEdit form-control" name="WiFiDNSAddr[1]" value="<?php echo $WiFiDNSAddr[1] ?>"/>
                                                                </span>
                                                            </div>
                                                            <div class="col-md-3">
                                                                <label class="control-label" for="spinEdit39" id="Label38"></label>
                                                                <span class="input-group-addon">
                                                                     <input type="text" id="spinEdit39" class="aSpinEdit form-control" name="WiFiDNSAddr[2]" value="<?php echo $WiFiDNSAddr[2] ?>"/>
                                                                </span>
                                                            </div>
                                                            <div class="col-md-3">
                                                                <label class="control-label" for="spinEdit40" id="Label39"></label>
                                                                <span class="input-group-addon">
                                                                     <input type="text" id="spinEdit40" class="aSpinEdit form-control" name="WiFiDNSAddr[3]" value="<?php echo $WiFiDNSAddr[3] ?>"/>
                                                                </span>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-6 col-md-offset-4">
                                            <ul class="pager">
                                                <li class="edit">
                                                    <a id="ip_change" href="#" onclick="document.getElementById('cont_wifi_ip').submit();">
                                                        Save Address Changes 
                                                        <span class="glyphicon glyphicon-save"></span>
                                                        <span class="sr-only">(current)</span>
                                                    </a>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
								</div> 
							  </form>
							</div>
						</div>
                  </div>
            </div>
          </div>
          <?php require('footer.php'); ?>
        </div>  
      </div>       
    <?php require('js_footer.php'); ?>
  </body>
</html>
